package com.zipcodewilmington.gildedrose;

import org.junit.Assert;
import org.junit.Test;

public class InventoryTest {

    @Test
    public void updateQuantityTest(){
        //test item that should go down 1 quality in 1 day
        Item item = new Item("A book", 12, 20);
        Item[] items = {item};

        Inventory inv = new Inventory(items);
        inv.updateQuality02();
        Assert.assertEquals(19, item.getQuality());
    }

    @Test
    public void updateQuantityTest02(){
        //test item that should go down two quality in 1 day
        Item item = new Item("A book", -1, 20);
        Item[] items = {item};

        Inventory inv = new Inventory(items);
        inv.updateQuality02();
        System.out.println(item.getQuality());
        Assert.assertEquals(18, item.getQuality());
    }

    @Test
    public void updateQuantityTest03(){
        //test aged brie that should increase in quality twice
        Item item = new Item("Aged Brie", -1, 15);
        Item[] items = {item};

        Inventory inv = new Inventory(items);
        inv.updateQuality02();
        Assert.assertEquals(17, item.getQuality());
    }

    @Test
    public void updateQuantityTest04() {
        //test that tickets for TAFKAL80ETC goes up three times
        Item item = new Item("Backstage passes to a TAFKAL80ETC concert", 5, 15);
        Item[] items = {item};

        Inventory inv = new Inventory(items);
        inv.updateQuality02();
        Assert.assertEquals(18, item.getQuality());
    }

    @Test
    public void updateQuantityTest05() {
        //test that tickets for TAFKAL80ETC goes up three times
        Item item = new Item("Aged Brie", 0, 15);
        item.setName("A book");
        item.setSellIn(50);
        Item[] items = {item};

        Inventory inv = new Inventory(items);
        inv.updateQuality02();
        Assert.assertEquals(14, item.getQuality());
    }

    @Test
    public void updateQuantityTest06() {
        //test that tickets for TAFKAL80ETC goes up three times
        Item item = new Item("Backstage passes to a TAFKAL80ETC concert", -3, 15);
        Item[] items = {item};

        Inventory inv = new Inventory(items);
        inv.updateQuality02();
        Assert.assertEquals(0, item.getQuality());
    }

    @Test
    public void updateQuantityTest07() {
        //test that tickets for TAFKAL80ETC goes up three times
        Item item = new Item("Sulfuras, Hand of Ragnaros", 0, 15);
        Item[] items = {item};

        Inventory inv = new Inventory(items);
        inv.updateQuality02();
        Assert.assertEquals(15, item.getQuality());
    }

    @Test
    public void updateQuantityTest08() {
        //test that tickets for TAFKAL80ETC goes up three times
        Item item = new Item("Conjured Item", -1, 15);
        Item[] items = {item};

        Inventory inv = new Inventory(items);
        inv.updateQuality02();
        Assert.assertEquals(11, item.getQuality());
    }
}